# Class SpliceTypes

java.lang.Object
org.snpeff.spliceSites.SpliceTypes

public class SpliceTypes extends Object
Analyze sequences from splice sites

Author:
  pcingola

## Field Summary

Fields
Modifier and Type
Field
Description
`static int`
`MAX_SPLICE_SIZE`
`static int`
`SIZE_BRANCH`
`static final int`
`THRESHOLD_COUNT`
`static final double`
`THRESHOLD_ENTROPY`
`static final double`
`THRESHOLD_P`

## Constructor Summary

Constructors
Constructor
Description
`SpliceTypes(Config config)`

## Method Summary

Modifier and Type
Method
Description
`Tuple<Double,Integer>`
`addBestU12Score(Transcript tr, String chrSeq, String donorAcceptor, int intronStart, int intronEnd)`
Calculate the best U12 score.
`boolean`
`analyzeAndCreate()`
Analyze and create conserved splice sites donor-acceptor pairs.
`Tuple<Double,Integer>`
`bestU12Score(String seq)`
Find the best score for PWM matrix in U12 branch points
`double`
`branchU12Threshold(double thresholdU12Percentile)`
Calculate threshold of U12 PWM scores Pick the score that gives a 'thresholdU12Percentile'.
`void`
`createSpliceFasta(String outputDir)`
Create one fasta file for each donor-acceptor pair
`String`
`getAcceptor(int i)`
`String`
`getAcceptorsByIntron(String intronKey)`
`String`
`getBranchByIntron(String intronKey)`
`List<SpliceSiteBranchU12>`
`getBranchU12(String donorAcceptor)`
Add a SpliceSiteBranchU12 for this donor-Acceptor pair
`String`
`getDonor(int i)`
`int`
`getDonorAccPairSize()`
`String`
`getDonorByIntron(String intronKey)`
`Set<String>`
`getIntronKeySet()`
`void`
`setDebug(boolean debug)`
`void`
`setGenomeFasta(String genomeFasta)`
`void`
`setTranscriptSet(TranscriptSet transcriptSet)`
`void`
`setVerbose(boolean verbose)`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### MAX_SPLICE_SIZE

public static int MAX_SPLICE_SIZE

### SIZE_BRANCH

public static int SIZE_BRANCH

### THRESHOLD_ENTROPY

public static final double THRESHOLD_ENTROPY

See Also:
  - Constant Field Values

### THRESHOLD_COUNT

public static final int THRESHOLD_COUNT

See Also:
  - Constant Field Values

### THRESHOLD_P

public static final double THRESHOLD_P

See Also:
  - Constant Field Values

## Constructor Details

### SpliceTypes

public SpliceTypes(Config config)

## Method Details

### addBestU12Score

public Tuple<Double,Integer> addBestU12Score(Transcript tr, String chrSeq, String donorAcceptor, int intronStart, int intronEnd)
Calculate the best U12 score. If the score is higher than 'thresholdU12Score' then add the chr:pos data to a list

Returns:
  A Tupleinvalid input: '<'Double, Integer> having the best score and best position

### analyzeAndCreate

public boolean analyzeAndCreate()
Analyze and create conserved splice sites donor-acceptor pairs.

### bestU12Score

public Tuple<Double,Integer> bestU12Score(String seq)
Find the best score for PWM matrix in U12 branch points

Parameters:
  `seq` -
Returns:
  A Tupleinvalid input: '<'Double, Integer> having the best score and best position

### branchU12Threshold

public double branchU12Threshold(double thresholdU12Percentile)
Calculate threshold of U12 PWM scores Pick the score that gives a 'thresholdU12Percentile'. E.g. branchU12Threshold(0.95) gives the 95% percentile threshold

### createSpliceFasta

public void createSpliceFasta(String outputDir)
Create one fasta file for each donor-acceptor pair

### getAcceptor

public String getAcceptor(int i)

### getAcceptorsByIntron

public String getAcceptorsByIntron(String intronKey)

### getBranchByIntron

public String getBranchByIntron(String intronKey)

### getBranchU12

public List<SpliceSiteBranchU12> getBranchU12(String donorAcceptor)
Add a SpliceSiteBranchU12 for this donor-Acceptor pair

### getDonor

public String getDonor(int i)

### getDonorAccPairSize

public int getDonorAccPairSize()

### getDonorByIntron

public String getDonorByIntron(String intronKey)

### getIntronKeySet

public Set<String> getIntronKeySet()

### setDebug

public void setDebug(boolean debug)

### setGenomeFasta

public void setGenomeFasta(String genomeFasta)

### setTranscriptSet

public void setTranscriptSet(TranscriptSet transcriptSet)

### setVerbose

public void setVerbose(boolean verbose)